// combo anywhere search
    #include "hmg.ch"
    
    PROC Main()

       set navigation extended
       public aCountries := HB_ATOKENS( MEMOREAD( "Countries.lst" ),   CRLF )
       public aCities := HB_ATOKENS( MEMOREAD( "LargCits.lst" ),   CRLF )
       
       
       ASORT( aCountries )                    // This Array MUST be sorted
       ASORT( aCities )                    // This Array MUST be sorted
       
       
           
       DEFINE WINDOW frmCSBTest ;
          AT 0,0 ;
          WIDTH 550 ;
          HEIGHT 300;
          TITLE 'ComboBox Anywhere Test' ;
          MAIN
         
          ON KEY ESCAPE ACTION frmCSBTest.Release

          define label l2
             row 15
             col 100
             width 100
             value 'Name'
          end label
          define textbox t1
             row 15
             col 200
             width 200
          end textbox
          
          define label countries
             row 45
             col 100
             width 100
             value "Countries"
          end label

          define combobox s1
             row 45
             col 200
             width 200
             fontname "Courier"
             fontitalic .t.
             fontbold .t.
             fontcolor {255,255,255}
             backcolor {0,0,255}
             items acountries
             ongotfocus _ComboBoxAnywhereSearchInit( .t. )
             onlostfocus _ComboBoxAnywhereSearchClose( )
          end combobox
          define label l3
             row 75
             col 100
             width 100
             value 'Text'
          end label
          define textbox t2
             row 75
             col 200
             width 200
          end textbox
          define label countries1
             row 105
             col 100
             width 100
             value "City"
          end label

          define combobox s2
             row 105
             col 200
             width 200
             fontname "Courier"
             fontitalic .t.
             fontbold .t.
             fontcolor {255,255,255}
             backcolor {0,0,255}
             items acities
             ongotfocus _ComboBoxAnywhereSearchInit( .t. )
             onlostfocus _ComboBoxAnywhereSearchClose( )
          end combobox
       
       END WINDOW // frmCSBTest
       Create Event ProcName _ComboBoxAnywhereSearch( 's1', 'frmcsbtest' ) HWND GetControlHandle ( 's1', 'frmCSBTest' )
       Create Event ProcName _ComboBoxAnywhereSearch( 's2', 'frmcsbtest' ) HWND GetControlHandle ( 's2', 'frmCSBTest' )
       frmCSBTest.Center
       frmCSBTest.Activate
    RETU // Main()

function _ComboBoxAnywhereSearchInit( lShowLabel )
   public _cComboSearchString := ''
   if lShowLabel
      if .not. iscontroldefined( _combolabel, &( thiswindow.name ) )
         define label _combolabel
            parent &(thiswindow.name) 
            row thiswindow.height - 80
            col this.col 
            width this.width 
            backcolor { 0, 0, 255 }
            fontcolor { 255, 255, 255 }
            fontname this.fontname
            fontsize 14
            fontbold .t.
            autosize .t.
         end label
      endif         
   endif   
   return nil
    
function _ComboBoxAnywhereSearchClose( )
   if __mvexist( '_cComboSearchString' )
      _cComboSearchString := ''
   endif
   if iscontroldefined( _combolabel, &(thiswindow.name))
      domethod( thiswindow.name, '_combolabel', 'RELEASE' )
   endif
   return nil
   
function _ComboBoxAnywhereSearch( cComboName, cWindowName )
   local lFound := .f.
   local nEventMsg := EventMsg()
   local ch
   local nVKDown := HMG_GetLastVirtualKeyDown()
   
   ch := HMG_GetLastCharacter()
   HMG_CleanLastCharacter( .t. )

   do case
   case nVKDown == VK_BACK   //   backspace
      HMG_CleanLastVirtualKeyDown()
      _cComboSearchString := HB_ULEFT( _cComboSearchString, max( 0, ( HMG_Len( _cComboSearchString ) - 1 ) ) )
   case nVKDown == VK_UP .or. nVKDown ==  VK_DOWN 
      HMG_CleanLastVirtualKeyDown()
      if hmg_len( _cComboSearchString ) == 0
         return nil
      else
         nLineNo := getproperty( cWindowName, cComboName, 'VALUE' )
         if nVKDown == VK_UP
            lFound := .f.
            for i := nLineNo - 1 to 1 step - 1
               // first check in the starting chars...
               if  hmg_upper( _cComboSearchString ) == hb_uleft( hmg_upper( getproperty( cWindowName, cComboName, 'ITEM', i ) ), hmg_len( _cComboSearchString ) )
                  lFound := .t.
                  setproperty( cWindowName, cComboName, 'VALUE', i )
                  exit
               endif  
            next i   
            if .not. lFound // anywhere searching...
               for i := nLineNo - 1 to 1 step - 1
                  if  HB_UAT( hmg_upper( _cComboSearchString ), hmg_upper( getproperty( cWindowName, cComboName, 'ITEM', i ) )  ) > 0
                     lFound := .t.
                     setproperty( cWindowName, cComboName, 'VALUE', i )
                     exit
                  endif  
               next i         
            endif   
            if .not. lFound
               playbeep()
            endif                 
         else // down key search for next   
            lFound := .f.
            for i := nLineNo + 1 to getproperty( cWindowName, cComboName, 'ITEMCOUNT' )
               // first check in the starting chars...
               if  hmg_upper( _cComboSearchString ) == hb_uleft( hmg_upper( getproperty( cWindowName, cComboName, 'ITEM', i ) ), hmg_len( _cComboSearchString ) )
                  lFound := .t.
                  setproperty( cWindowName, cComboName, 'VALUE', i )
                  exit
               endif  
            next i   
            if .not. lFound // anywhere searching...
               for i := nLineNo + 1 to getproperty( cWindowName, cComboName, 'ITEMCOUNT' )
                  if  HB_UAT( hmg_upper( _cComboSearchString ), hmg_upper( getproperty( cWindowName, cComboName, 'ITEM', i ) )  ) > 0
                     lFound := .t.
                     setproperty( cWindowName, cComboName, 'VALUE', i )
                     exit
                  endif  
               next i         
            endif   
            if .not. lFound
               playbeep()
            endif                 
         endif
         return 1 
      endif   
   case nVKDown ==  VK_RIGHT .or. nVKDown ==  VK_LEFT .or. nVKDown ==  VK_HOME .or. nVKDown ==  VK_END .or. EventIsMouseMessage ()
      HMG_CleanLastVirtualKeyDown()
      _cComboSearchString := ''
      return nil
   otherwise
      IF EventMsg() <> WM_CHAR
         Return Nil   // enable processing the current message
      ENDIF
      _cComboSearchString := _cComboSearchString + ch
   endcase

   lFound := .f.
   for i := 1 to getproperty( cWindowName, cComboName, 'ITEMCOUNT' )
      // first check in the starting chars...
      if  hmg_upper( _cComboSearchString ) == hb_uleft( hmg_upper( getproperty( cWindowName, cComboName, 'ITEM', i ) ), hmg_len( _cComboSearchString ) )
         lFound := .t.
         setproperty( cWindowName, cComboName, 'VALUE', i )
         exit
      endif  
   next i   
   if .not. lFound // anywhere searching...
      for i := 1 to getproperty( cWindowName, cComboName, 'ITEMCOUNT' )
         if  HB_UAT( hmg_upper( _cComboSearchString ), hmg_upper( getproperty( cWindowName, cComboName, 'ITEM', i ) )  ) > 0
            lFound := .t.
            setproperty( cWindowName, cComboName, 'VALUE', i )
            exit
         endif  
      next i         
   endif   
   if .not. lFound
      playbeep()
      _cComboSearchString := HB_ULEFT( _cComboSearchString, max( 0, ( HMG_Len( _cComboSearchString ) - 1 ) ) )
   endif      
   if iscontroldefined( _combolabel, &cWindowName )
      setproperty( cWindowName, '_combolabel', 'VALUE', _cComboSearchString )
   endif
   return 1
